<xsl:stylesheet xmlns:xsl='http://www.w3.org/1999/XSL/Transform' xmlns:saxon="http://icl.com/saxon" extension-element-prefixes="saxon" version="1.0" xmlns:sch="http://www.ascc.net/xml/schematron">  

<!-- a stylesheet to generate sounds with sable (from examples) -->

<xsl:template match="/">
  <xsl:apply-templates select="examples"/>
  <saxon:output file="../Output/all.sh" method="text">
   <xsl:apply-templates select="examples" mode="bat"/>
  </saxon:output>
</xsl:template>



<xsl:template match="/examples">
  <xsl:apply-templates/>
</xsl:template>


<xsl:template match="example">
   <xsl:for-each select="source/sable">
    <saxon:output file="../OutputAural/{ancestor::example/@id}.sable" method="xml">
      <xsl:copy-of select="*"/>
    </saxon:output>
   </xsl:for-each>
</xsl:template>


<xsl:template match="/examples" mode="bat">
   <xsl:for-each select="example/source/sable">
    <xsl:text>towav.sh </xsl:text>
    <xsl:value-of select="concat('../OutputAural/',ancestor::example/@id,'.sable')"/>
    <xsl:text> -o </xsl:text>
    <xsl:value-of select="concat('../OutputAural/',ancestor::example/@id,'.sable.wav')"/>
    <xsl:text> -otype wav;
</xsl:text>
   </xsl:for-each>
</xsl:template>


</xsl:stylesheet>
